#!/system/bin/sh
TAG="InitVariant"

###################################################
install_provision()
{
  local status=0
  local prov_file_name="provision.zip"
  local prov_file="/cache/$prov_file_name"
  local prov_file_bak="/cache/recovery/$prov_file_name"
  local recovery_dir="/cache/recovery"
  local status_file="$recovery_dir/last_install"
  local command_file="$recovery_dir/command"
  local first_time_flag="/vendor/device/factory_provision"
  local provision_ready_flag="/vendor/device/installed_variant"

  if [ -f $prov_file -o -f $prov_file_bak ]; then
    if [ -f $prov_file_bak ]; then
      mv $prov_file_bak $prov_file
    fi
    if [ -f $status_file ]; then
      status=$(busybox sed -n '/provision.zip/{n;p;}' $status_file)
    fi
    if [ ! "-$status-" = "-1-" ]; then
      rm -r $recovery_dir
      mkdir -p $recovery_dir
      echo "--update_package=$prov_file" > $command_file
      log -t $TAG "$prov_file found - Installing"
      sync
      sleep 1
      reboot recovery
      sleep 5
    else
      touch $first_time_flag
      sync
    fi
  else
    if [ ! -e $first_time_flag ]; then
      if [ ! -e $provision_ready_flag ]; then
	log -t $TAG "No $prov_file found - reboot"
	echo "No $prov_file found - reboot" > /dev/console
	sleep 3
	reboot
	sleep 5
      fi
    fi
  fi
}
###################################################

if [ $# = 1 ]; then
  if [ $1 = 1 ]; then
    install_provision
  fi
fi
#EOF
